searchNodes=[{"doc":"harness the boilerplate!","ref":"Harness.html","title":"Harness","type":"module"},{"doc":"","ref":"Harness.html#ignore_patterns/0","title":"Harness.ignore_patterns/0","type":"function"},{"doc":"","ref":"Harness.html#version/0","title":"Harness.version/0","type":"function"},{"doc":"A local project's harness configuration","ref":"Harness.Manifest.html","title":"Harness.Manifest","type":"module"},{"doc":"Loads the manifest onto the project stack and loads dependenciesBy clearing and pushing a fake project onto the Mix.ProjectStack, we can utilize large parts of the Mix codebase without much hacking or rewriting.This function clears the existing stack and pushes a configuration onto it. Most of the configuration follows the defaults, but the dependencies are read from the harness manifest (harness.exs) and the dependency versions are locked to harness.lock.","ref":"Harness.Manifest.html#load/1","title":"Harness.Manifest.load/1","type":"function"},{"doc":"reads the manifest file from the path","ref":"Harness.Manifest.html#read/1","title":"Harness.Manifest.read/1","type":"function"},{"doc":"A behaviour for defining harness package modules.Harness packages should add a pkg.exs to their root directory which describes a single module which implements this behaviour.","ref":"Harness.Pkg.html","title":"Harness.Pkg","type":"behaviour"},{"doc":"A function to transform incoming opts (in keyword format) into a package's struct (t/0).The simplest cast/1 is like so:def cast(opts), do: struct(__MODULE__, opts)","ref":"Harness.Pkg.html#c:cast/1","title":"Harness.Pkg.cast/1","type":"callback"},{"doc":"A list of links to create from the .harness directory to project root.The link can be a string path which will be created as a symlink or the link can be a tuple with the path and an atom declaring the type of link as :sym or :hard.","ref":"Harness.Pkg.html#c:links/1","title":"Harness.Pkg.links/1","type":"callback"},{"doc":"","ref":"Harness.Pkg.html#otp_app/1","title":"Harness.Pkg.otp_app/1","type":"function"},{"doc":"","ref":"Harness.Pkg.html#path/1","title":"Harness.Pkg.path/1","type":"function"},{"doc":"A package module's struct","ref":"Harness.Pkg.html#t:t/0","title":"Harness.Pkg.t/0","type":"type"},{"doc":"Helper functions for rendersThese functions are accessible inside templates.","ref":"Harness.Renderer.Helpers.html","title":"Harness.Renderer.Helpers","type":"module"},{"doc":"Either inspects an item or interpolates it.If the item is a binary, it is interpolated. Else, it is inspected with Kernel.inspect/2 and then interpolated.","ref":"Harness.Renderer.Helpers.html#inspect_or_interpolate/1","title":"Harness.Renderer.Helpers.inspect_or_interpolate/1","type":"function"},{"doc":"Converts a string or atom into PascalCaseMakes use of the Macro.camelize/1 function underneath.","ref":"Harness.Renderer.Helpers.html#pascal/1","title":"Harness.Renderer.Helpers.pascal/1","type":"function"},{"doc":"Renders things as a treeSee the original implementation in Mix here.The original implementation has an optimization for dependency trees which prevents showing the same dependency tree twice. That's great for printing small dependency trees, but for file trees, we want to see the entire tree every time, even if a file or directory name is present many times.The changes to the original implementation are shown as comments below:","ref":"Harness.Tree.html","title":"Harness.Tree","type":"module"},{"doc":"Prints the given tree according to the callback. The callback will be invoked for each node and it must return a {printed, children} tuple.","ref":"Harness.Tree.html#print_tree/3","title":"Harness.Tree.print_tree/3","type":"function"},{"doc":"Renders harness packages into the current directoryConfiguration of which files to generate and link is according to the current directory's harness manifest (harness.exs).","ref":"Mix.Tasks.Harness.html","title":"Mix.Tasks.Harness","type":"task"},{"doc":"Removes links, files, and directories generated by harness","ref":"Mix.Tasks.Harness.Clean.html","title":"Mix.Tasks.Harness.Clean","type":"task"},{"doc":"Compiles harness package dependenciesLoads the current harness manifest, checks to ensure dependencies have been feteched, and then compiles harness package files.","ref":"Mix.Tasks.Harness.Compile.html","title":"Mix.Tasks.Harness.Compile","type":"task"},{"doc":"Fetches harness dependencies according to a harness.exsHarness dependencies follow the same format and rules as mix dependencies: you may use (public/private) hex, git, or local paths, and dependencies may be semantically versioned when fetched via hex.","ref":"Mix.Tasks.Harness.Get.html","title":"Mix.Tasks.Harness.Get","type":"task"},{"doc":"Updates harness dependencies according to a harness.exsThis task mimics mix deps.update (and uses it for the implementation). Any options are passed directly to the invocation of mix deps.update","ref":"Mix.Tasks.Harness.Update.html","title":"Mix.Tasks.Harness.Update","type":"task"},{"doc":"HarnessA command line tool for harnessing Elixir boilerplate.See the hex guides for detail documentation.","ref":"readme.html","title":"Harness","type":"extras"},{"doc":"Interested in developing harness? Currently it's in a tight spot because it doesn't have any test cases. Your best bet for blessing harness is to build and install harness archives locally and use the local installation to harness packages like harness_micro_controller.mix archive.uninstall harness --force MIX_ENV=prod mix archive.build mix archive.install harness-0.0.0.ez --force","ref":"readme.html#development","title":"Harness - Development","type":"extras"},{"doc":"Harness is installed as an archive:mix archive.install hex harness --forceHarness depends on elixir 1.9+. If you use asdf:asdf install erlang 22.3 asdf install elixir 1.10.4-otp-22 asdf global erlang 22.3 asdf global elixir 1.10.4-otp-22 mix archive.install hex harness --force","ref":"readme.html#installation","title":"Harness - Installation","type":"extras"},{"doc":"ChangelogAll notable changes to this project will be documented in this file.The format is based on Keep a Changelog, and this project adheres to Semantic Versioning.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"AddedAdded support for hard linking to files in .harnessUpdated the Harness.Pkg behaviour to declare links with a tuple that includes the link type :sym or :harde.g. {&quot;mix.exs&quot;, :sym} or {&quot;.github/workflows/ci.yml&quot;, :hard}","ref":"changelog.html#0-5-0-2021-02-24","title":"Changelog - 0.5.0 - 2021-02-24","type":"extras"},{"doc":"AddedAdded a config :harness, :version key which checks the version of harness and ensures that a manifest is only rendered if the harness version matches","ref":"changelog.html#0-4-0-2021-02-19","title":"Changelog - 0.4.0 - 2021-02-19","type":"extras"},{"doc":"AddedAdded a :skip_files key to the configuration of a manifest, allowing one to provide a list of regex which will be checked against while sourcing files. Any files found to match any of the regex will be excluded from generation.this allows a service author to 'take the reins' for that file","ref":"changelog.html#0-3-0-2021-02-17","title":"Changelog - 0.3.0 - 2021-02-17","type":"extras"},{"doc":"FixedFixed a broken link to the Getting Started guide from the About guide","ref":"changelog.html#0-2-9-2020-11-02","title":"Changelog - 0.2.9 - 2020-11-02","type":"extras"},{"doc":"AddedAdded a mix harness.update task that mimics mix deps.update","ref":"changelog.html#0-2-8-2020-10-15","title":"Changelog - 0.2.8 - 2020-10-15","type":"extras"},{"doc":"FixedMisc. documentation fixes including:a broken link to the Getting Started guideaddition of GitHub and Changelog links to hex pagedefault documentation page is set to the README","ref":"changelog.html#0-2-7-2020-10-15","title":"Changelog - 0.2.7 - 2020-10-15","type":"extras"},{"doc":"FixedFixed a bug present when running mix harness.compile in Elixir 1.11+","ref":"changelog.html#0-2-6-2020-10-12","title":"Changelog - 0.2.6 - 2020-10-12","type":"extras"},{"doc":"ChangedHarness now explicitly depends on :eex as an extra_applicationthis resolves compilation warnings on elixir 1.11+","ref":"changelog.html#0-2-5-2020-10-06","title":"Changelog - 0.2.5 - 2020-10-06","type":"extras"},{"doc":"ChangedGenerated files are now formatted to a column width of 80","ref":"changelog.html#0-2-4-2020-10-05","title":"Changelog - 0.2.4 - 2020-10-05","type":"extras"},{"doc":"ChangedHarness is now published to public hex","ref":"changelog.html#0-2-3-2020-09-22","title":"Changelog - 0.2.3 - 2020-09-22","type":"extras"},{"doc":"AddedKernel functions are now imported for templates by default.e.g. ==/2 or inspect/2","ref":"changelog.html#0-2-2-2020-08-30","title":"Changelog - 0.2.2 - 2020-08-30","type":"extras"},{"doc":"FixedFixed a bug where multiple copies of the same directory would show if the directory contained multiple files to be linked","ref":"changelog.html#0-2-1-2020-08-27","title":"Changelog - 0.2.1 - 2020-08-27","type":"extras"},{"doc":"ChangedManifests are now written with the Config APItherefore the manifest version has increased to v2.0.0As a result of the above, harness now requires at least Elixir 1.9 for compatibility","ref":"changelog.html#0-2-0-2020-08-26","title":"Changelog - 0.2.0 - 2020-08-26","type":"extras"},{"doc":"AddedA function to interpolate or inspect items into a template","ref":"changelog.html#0-1-2-2020-08-25","title":"Changelog - 0.1.2 - 2020-08-25","type":"extras"},{"doc":"AddedElixir LS files are now ignored from generation","ref":"changelog.html#0-1-1-2020-08-25","title":"Changelog - 0.1.1 - 2020-08-25","type":"extras"},{"doc":"AddedImprovements to display. First stable-ish release","ref":"changelog.html#0-1-0-2020-08-25","title":"Changelog - 0.1.0 - 2020-08-25","type":"extras"},{"doc":"AddedVim swap files are now ignored from template directoriesFixedThe harness project is reloaded after mix harness.compile when running mix harnessthis fixes an issue where otp app atoms could not be determined on clean harness runs, as in CIRemovedThe Harness.Cache module has been removednow harness caches packages by downloading them to the deps/ directorythis behaviour mimics mix","ref":"changelog.html#0-0-1-2020-08-24","title":"Changelog - 0.0.1 - 2020-08-24","type":"extras"},{"doc":"AddedInitial dependency management and generation abilities","ref":"changelog.html#0-0-0-2020-08-24","title":"Changelog - 0.0.0 - 2020-08-24","type":"extras"},{"doc":"AddedThis project was generated by Gaas","ref":"changelog.html#initial-commit-2020-08-19","title":"Changelog - initial commit - 2020-08-19","type":"extras"},{"doc":"WelcomeWelcome to the harness documentation. As in the notorious Captain Underpants novels, you may choose your own adventure:What is harness?Let's Get Started!","ref":"welcome.html","title":"Welcome","type":"extras"},{"doc":"About HarnessThere are many ways to describe harness. Harness:simplifies writing tiny isolated services by dynamically generating unecessary boilerplate filesmakes it easy to version your practiceslets you make a library out of anything!But overall, harness is really about one thing: service chassis (plural).","ref":"about.html","title":"About Harness","type":"extras"},{"doc":"What's a service chassis? A service chassis is a collection of tooling that sets the bar for what makes one of your services one of your services. For example, in our Elixir shoppe, we have a service chassis that includes:asdf for language version managementexcoveralls for testing coveragecredo for lintingdistillery for release buildingAppsignal for error reporting and metricsAnd more (I can't give all our secrets away, can I? ;).For these, we need a .tool-versions, a .credo.exs, a coveralls.json, a rel/config.exs and rel/.formatter.exs, and configuration and in-application-space code changes for Appsignal. Seems like a lot? Imagine all the other configuration I'm not even mentioning like private tooling and Dockerfiles!If you have one service running your business, this isn't too big of a deal. One times the aforementioned number of configuration files isn't too bad. It's manageable. But what about if you have 10 services? 50? 100?","ref":"about.html#services-chassis","title":"About Harness - Services Chassis","type":"extras"},{"doc":"If your organization employs a micro-service architecture and you've developed more than 20 services, you have probably used a static code generation tool. They're great! Plug in X Y and Z like the repository name, application name, and secret key-base, and you can have a fresh phoenix app up and running in no time!In our organization, we have a centralized static code generation tool called GaaS (Git as a Service). A LiveView front-end plus a DSL for easy templates equals a very nice user experience for generating new code. GitHub templates are a free and ready-to-use alternative. mix_generator is another good tool for Elixir projects in specific.We used static code generation tools alone for a long time with great effect.","ref":"about.html#enter-static-code-generation-tooling","title":"About Harness - Enter static code generation tooling","type":"extras"},{"doc":"So what's the big deal then if static code generation tools work so well? The problem lies in how your organization adopts and alters practices over time.Consider this scenario: in an app, you add a new way of doing something that may be useful for all apps, like using the (shameless plug) bless library for running the gambit on your testing/linting suite. It's a great practice, so let's add it to all our services! To do so, we first modify our mix.exs generator(s) to depend on and/or configure bless. Then we can either run the updated generator(s) over existing codebases or manually change those services. With 10 or so services either way is fine, but over 20 or 50 or 100 services? Even small changes start to hurt.","ref":"about.html#where-static-code-generation-tools-fall-short","title":"About Harness - Where static code generation tools fall short","type":"extras"},{"doc":"Harness takes a different approach. Harness is more like a package manager (think the mix+hex relationship or npm/yarn or cargo crates). Imagine if you checked in all the node_modules/ stuff from npm? Gross. Like red wine in a white carpet. Finding any specific file in that mess? Impossible. Changing that directory across hundreds of repositories? Herculean.Instead, the harness approach is to describe everything a static code generation tool does with a manifest, and then never check in the generated files.","ref":"about.html#enter-harness","title":"About Harness - Enter Harness","type":"extras"},{"doc":"Manifests describe a plan. They don't detail the specifics like which versions of dependencies we'll use exactly (think a mix.lock) but rather a set of rules or guidelines to use to form a project.For harness, this is the harness.exs.Enough of the theory though, let's Get Started!","ref":"about.html#manifests","title":"About Harness - Manifests","type":"extras"},{"doc":"Getting StartedLet's get going!First, you need a recent version of elixir (~&gt; 1.9). Consider trying asdf as a language version management tool. Now install harness:mix archive.install hex harness --forceRun mix help harness to verify installation.","ref":"gettingstarted.html","title":"Getting Started","type":"extras"},{"doc":"There are a few components that make up a harnessed repository.Like a regular mix project, a harness project typically has:lib/ containing your application-space codetest/ unit tests for application-space code in lib/config/ configurationBut none of these are requirements for harness. For a harness project, all you really need is a harness manifest.Once you have a manifest, a run of mix harness.get in that directory will fetch harness packages (think dependencies), and then a run of mix harness will render the project.","ref":"gettingstarted.html#making-a-harness-project","title":"Getting Started - Making a harness project","type":"extras"},{"doc":"Say that we have a tiny service in our stack called a micro (µ) controller. It's a single phoenix controller (in reality, just a plug) that handles a request and performs some action. Setting up a whole service chassis for a service this small might be annoying, but with a well-groomed harness micro controller package, it can be quite simple.Say you have a git repo for a µ controller that looks like this:$ tree -a -I '.git' . ├── .github │   ├── settings.yml │   ├── stale.yml │   └── workflows │   └── ci.yml ├── .gitignore ├── README.md ├── config │   ├── config.exs │   ├── dev.exs │   ├── prod.exs │   └── test.exs ├── harness.exs ├── lib │   ├── access_token_controller.ex │   ├── access_token_fetcher.ex │   └── access_token_verifier.ex ├── mix.lock └── test ├── access_token_controller_test.exs └── support └── mocks.ex 6 directories, 16 filesIn a directory with a harness-file (harness.exs), a run of mix harness will generate a .harness/ directory containing generated boilerplate, with the necessary symlinking and path adjusting to make the project run like a normal phoenix project.For example, the above repository would expand to something like:$ mix harness $ tree -a -I '.git|_build|deps|.elixir_ls|cover' . ├── .credo.exs -&gt; .harness/.credo.exs ├── .dockerignore -&gt; .harness/.dockerignore ├── .formatter.exs -&gt; .harness/.formatter.exs ├── .github │   ├── settings.yml │   ├── stale.yml │   └── workflows │   └── ci.yml ├── .gitignore ├── .harness │   ├── .credo.exs │   ├── .dockerignore │   ├── .formatter.exs │   ├── .tool-versions │   ├── Dockerfile │   ├── config │   │   ├── config.exs │   │   ├── dev.exs │   │   ├── prod.exs │   │   └── test.exs │   ├── coveralls.json │   ├── lib │   │   ├── authentication_service_access_token_controller │   │   │   └── application.ex │   │   ├── authentication_service_access_token_controller_web │   │   │   ├── channels │   │   │   ├── controllers │   │   │   │   └── version_controller.ex │   │   │   ├── endpoint.ex │   │   │   ├── gettext.ex │   │   │   ├── router.ex │   │   │   └── views │   │   │   ├── error_helpers.ex │   │   │   └── error_view.ex │   │   └── authentication_service_access_token_controller_web.ex │   ├── mix.exs │   ├── rel │   │   └── config.exs │   └── test │   ├── authentication_service_access_token_controller_web │   │   ├── controllers │   │   │   └── version_controller_test.exs │   │   ├── live │   │   └── views │   │   └── error_view_test.exs │   ├── support │   │   ├── conn_case.ex │   │   └── mock_release_handler.ex │   └── test_helper.exs ├── .tool-versions -&gt; .harness/.tool-versions ├── README.md ├── config │   ├── config.exs │   ├── dev.exs │   ├── prod.exs │   └── test.exs ├── coveralls.json -&gt; .harness/coveralls.json ├── harness.exs ├── lib │   ├── access_token_controller.ex │   ├── access_token_fetcher.ex │   └── access_token_verifier.ex ├── mix.exs -&gt; .harness/mix.exs ├── mix.lock └── test ├── access_token_controller_test.exs ├── support │   └── mocks.ex └── test_helper.exs -&gt; ../.harness/test/test_helper.exs 21 directories, 48 filesGenerally the workflow for a run of mix harness isread the configuration in harness.exsdetermine a data structure that satisfies the configurationrun that configuration through template generatorsstore the generated files in .harness/create any necessary symlinks from .harness/ to ./","ref":"gettingstarted.html#example-a-micro-controller","title":"Getting Started - Example: a micro controller","type":"extras"},{"doc":"ManifestsTL;DR: harness.exs describes how a harness project should be rendered.What's a manifest anyways? A manifest typically describes a plan. A mix.exs is a kind of manifest. It describes which dependencies a project relies on, how it should be compiled, configured, tested, documented, and published. Notice, though, what a mix.exs doesn't describe:an exact list of files to compile, test, or documentan exact specification on dependency versionsFor that information, you might have other more specific manifests or lockfiles: files which lock exact information into place.","ref":"manifests.html","title":"Manifests","type":"extras"},{"doc":"The harness manifest API piggy-backs off the elixir 1.9+ Config API.A minimal harness.exs looks like so:import Config config :harness, manifest_version: &quot;2.0.0&quot;, generators: [], deps: []","ref":"manifests.html#manifest-configuration","title":"Manifests - Manifest Configuration","type":"extras"}]